/*
 * bsd-2-clause
 *
 * Copyright (c) 2018 Jacek Łysiak
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *  this list of conditions and the following disclaimer in the documentation
 *  and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
 * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

package pl.edu.mimuw.cloudatlas.agent.modulelayer.module.query.query;

import pl.edu.mimuw.cloudatlas.datamodel.attribute.Attribute;

import java.util.Arrays;

import static pl.edu.mimuw.cloudatlas.common.security.SignerCipher.generateDescriptor;

public class QueryAttribute {
    /// SQL-like query program
    private final String queryString;

    /// Query attribute name
    private final Attribute name;

    /**
     *  Signature generated by signer.
     *  In short: priv-key-encrypted( hash( query-descriptor ) )
     */
    private final byte[] signature;

    /// Unique id generated by signer
    private final long id;

    /// Query has been makred as deleted?
    private final boolean deleted;

    private QueryAttribute() {
        queryString = null;
        id = 0;
        signature = new byte[0];
        name = null;
        deleted = false;
    }

    public QueryAttribute(String queryString, Attribute name, long id, byte[] signature, boolean deleted) {
        this.queryString = queryString;
        this.id = id;
        this.signature = signature;
        this.name = name;
        this.deleted = deleted;
    }

    public QueryAttribute(QueryAttribute q) {
        queryString = q.queryString;
        name = q.name;
        signature = q.getSignature().clone();
        id = q.id;
        deleted = q.deleted;
    }

    public String getName() {
        return name != null ? name.toString() : null;
    }

    public Attribute getAttribute() {
        return name;
    }


    public byte[] getSignature() {
        return signature;
    }

    public boolean isDeleted() {
        return deleted;
    }

    public long getId() {
        return id;
    }

    public String getQueryString() {
        return queryString;
    }

    public byte[] getDescriptor() {
        return generateDescriptor(name, queryString, id);
    }

    @Override
    public String toString() {
        return String.format("{%s, %s, %s, %s, %s}",queryString, name, Arrays.toString(signature), id,deleted );
    }
}
